pred show {}
run  show for 10
abstract sig integer{val : Int}
abstract sig string{val : Int}

abstract sig Class extends Classifier
{ isAbstract : lone Class_isAbstract
, associations : set @AssociationEnd
, superClass : set @Class }
{}
sig Class_isAbstract
{ parent : one Class }
{ parent = (Class <: isAbstract).this}
abstract sig Attribute
{ type : one @Type
, owner : one @Classifier }
{ (this) in (((@Attribute).(@owner)).(@attributes)) }
abstract sig AssociationEnd
{ lowerBound : one AssociationEnd_lowerBound
, upperBound : lone AssociationEnd_upperBound
, class : one @Class
, association : one @Association }
{}
sig AssociationEnd_lowerBound extends integer
{ parent : one AssociationEnd }
{ parent = (AssociationEnd <: lowerBound).this}
sig AssociationEnd_upperBound extends integer
{ parent : one AssociationEnd }
{ parent = (AssociationEnd <: upperBound).this}
abstract sig Association
{ ends : set @AssociationEnd }
{ 2 <= #ends and #ends <= 2 }
abstract sig Enumeration extends Type
{ ownedLiteral : set Enumeration_ownedLiteral }
{}
sig Enumeration_ownedLiteral extends EnumerationLiteral
{ parent : one Enumeration }
{ (parent) in ((this).(@enumeration)) }
abstract sig EnumerationLiteral
{ name : one EnumerationLiteral_name
, enumeration = @Enumeration }
{ all  x : (this).(@enumeration) | (this) in ((x).(@ownedLiteral)) }
sig EnumerationLiteral_name extends string
{ parent : one EnumerationLiteral }
{ parent = (EnumerationLiteral <: name).this}
abstract sig Type
{}
{}
abstract sig Classifier
{ attributes : set @Attribute }
{ all  x : (this).(@attributes) | (this) in ((x).(@owner)) }
fact { all disj x, y : @EnumerationLiteral | (((x).(@name)).(@val)) != (((y).(@name)).(@val)) }
one sig Float extends Type
{}
{}
one sig MString extends Type
{}
{}
one sig AddressResolutionTypes extends Enumeration
{}
{ all  x : (@AddressResolutionTypes).(@ownedLiteral) | (((((x).(@name)).(@val)) = (0)) or ((((x).(@name)).(@val)) = (1))) or ((((x).(@name)).(@val)) = (2)) }
one sig Product extends Class
{}
{ no (this).(@attributes) some (this).(@isAbstract) ((this).(@associations)) = (@Product2TaxRule) no (this).(@superClass) }
one sig Product2TaxRule extends AssociationEnd
{}
{ (((this).(@lowerBound)).(@val)) = (0) no (this).(@upperBound) ((this).(@class)) = (@Product) ((this).(@association)) = (@ProductTaxRule) }
one sig ProductTaxRule extends Association
{}
{ ((this).(@ends)) = ((@Product2TaxRule)+(@TaxRule2Product)) }
one sig TaxRule2Product extends AssociationEnd
{}
{ (((this).(@lowerBound)).(@val)) = (1) ((this).(@class)) = (@TaxRule) ((this).(@association)) = (@ProductTaxRule) }
one sig Name extends Attribute
{}
{ ((this).(@type)) = (@MString) ((this).(@owner)) = (@TaxRule) }
lone sig TaxCode extends Attribute
{}
{ ((this).(@type)) = (@MString) ((this).(@owner)) = (@TaxRule) }
lone sig Resolution extends Attribute
{}
{ ((this).(@type)) = (@AddressResolutionTypes) ((this).(@owner)) = (@TaxRule) }
lone sig ResolutionValue extends Attribute
{}
{ ((this).(@type)) = (@MString) ((this).(@owner)) = (@TaxRule) }
one sig TaxRule extends Class
{}
{ ((this).(@attributes)) = ((((@Name)+(@TaxCode))+(@Resolution))+(@ResolutionValue)) some (this).(@isAbstract) ((this).(@associations)) = (@TaxRule2Product) no (this).(@superClass) }
lone sig PercentageAttr extends Attribute
{}
{ ((this).(@type)) = (@Float) ((this).(@owner)) = (@PercentageTaxRule) }
lone sig PercentageTaxRule extends Class
{}
{ ((this).(@attributes)) = (@PercentageAttr) not (some (this).(@isAbstract)) no (this).(@associations) ((this).(@superClass)) = (@TaxRule) }
lone sig Amount extends Attribute
{}
{ ((this).(@type)) = (@Float) ((this).(@owner)) = (@SurchargeTaxRule) }
lone sig SurchargeTaxRule extends Class
{}
{ ((this).(@attributes)) = (@Amount) not (some (this).(@isAbstract)) no (this).(@associations) ((this).(@superClass)) = (@TaxRule) }
one sig eShop
{ storefront : one eShop_storefront }
{}
one sig eShop_storefront
{ parent : one eShop
, buypaths : one eShop_storefront_buypaths }
{}
one sig eShop_storefront_buypaths
{ parent : one eShop_storefront
, Checkout : one eShop_storefront_buypaths_Checkout }
{}
one sig eShop_storefront_buypaths_Checkout
{ parent : one eShop_storefront_buypaths
, Taxationoptions : one eShop_storefront_buypaths_Checkout_Taxationoptions }
{}
one sig eShop_storefront_buypaths_Checkout_Taxationoptions
{ parent : one eShop_storefront_buypaths_Checkout
, Customtaxation = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation }
{  some (eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation) }
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions
, TaxType : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType
, Ammountspecification : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification }
{}
one sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation
, Fixedratetaxation = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Fixedratetaxation
, Rulebasedtaxation = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation }
{  some (eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Fixedratetaxation + eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation) }
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Fixedratetaxation
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType }
{}
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType
, ResolutionType = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType }
{}
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation
, Country = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_Country
, Region = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_Region
, City = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_City }
{  some (eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_Country + eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_Region + eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_City) }
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_Country
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType }
{}
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_Region
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType }
{}
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType_City
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_TaxType_Rulebasedtaxation_ResolutionType }
{}
one sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation
, Surcharge = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification_Surcharge
, Percentage = eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification_Percentage }
{  some (eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification_Surcharge + eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification_Percentage) }
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification_Surcharge
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification }
{}
lone sig eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification_Percentage
{ parent : one eShop_storefront_buypaths_Checkout_Taxationoptions_Customtaxation_Ammountspecification }
{}
fact { (some @PercentageAttr) <=> (some @PercentageTaxRule) (some @Amount) <=> (some @SurchargeTaxRule) (some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@Ammountspecification)).(@Surcharge)) <=> (some @SurchargeTaxRule) (some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@Ammountspecification)).(@Percentage)) <=> (some @PercentageTaxRule) (some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Fixedratetaxation)) => ((((@TaxRule2Product).(@upperBound)).(@val)) = (1)) else (no (@TaxRule2Product).(@upperBound)) (some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation)) <=> (some @TaxCode) (some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation)) <=> (some @Resolution) (some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation)) <=> (some @ResolutionValue) some (((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation) (some (((((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation)).(@ResolutionType)).(@Country)) <=> ((0) in (((@AddressResolutionTypes).(@ownedLiteral)).(@name).val)) (some (((((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation)).(@ResolutionType)).(@Region)) <=> ((1) in (((@AddressResolutionTypes).(@ownedLiteral)).(@name).val)) (some (((((((((@eShop).(@storefront)).(@buypaths)).(@Checkout)).(@Taxationoptions)).(@Customtaxation)).(@TaxType)).(@Rulebasedtaxation)).(@ResolutionType)).(@City)) <=> ((2) in (((@AddressResolutionTypes).(@ownedLiteral)).(@name).val)) }
