pred show {}
run  show for 1


abstract sig ActivityNode
{ outgoing : set @ActivityEdge
, incoming : set @ActivityEdge }
{ all  x : (this).(@outgoing) | (this) in ((x).(@source))
  all  x : (this).(@incoming) | (this) in ((x).(@target)) }
abstract sig ActivityEdge
{ source : one @ActivityNode
, target : one @ActivityNode }
{ all  x : (this).(@source) | (this) in ((x).(@outgoing)) }
one sig inStart extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofStart) no (this).(@incoming) }
one sig ofStart extends ActivityEdge
{}
{ ((@ofStart).(@source)) = (@inStart) ((@ofStart).(@target)) = (@dnProductSource) }
one sig dnProductSource extends ActivityNode
{}
{ ((this).(@outgoing)) = ((((@ofEmail)+(@ofCatalog))+(@ofSearch))+(@ofWishlist)) ((this).(@incoming)) = (@ofStart) }
lone sig ofEmail extends ActivityEdge
{}
{ ((@ofEmail).(@source)) = (@dnProductSource) ((@ofEmail).(@target)) = (@aSelectProductInEmail) }
one sig ofCatalog extends ActivityEdge
{}
{ ((@ofCatalog).(@source)) = (@dnProductSource) ((@ofCatalog).(@target)) = (@aSelectProductFromCatalog) }
lone sig ofSearch extends ActivityEdge
{}
{ ((@ofSearch).(@source)) = (@dnProductSource) ((@ofSearch).(@target)) = (@aSearchProduct) }
lone sig ofWishlist extends ActivityEdge
{}
{ ((@ofWishlist).(@source)) = (@dnProductSource) ((@ofWishlist).(@target)) = (@aSelectProductFromWishlist) }
lone sig aSelectProductInEmail extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofEmails) ((this).(@incoming)) = (@ofEmail) }
one sig aSelectProductFromCatalog extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofCatalogs) ((this).(@incoming)) = (@ofCatalog) }
lone sig aSearchProduct extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofSearching) ((this).(@incoming)) = (@ofSearch) }
lone sig aSelectProductFromWishlist extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofWishLists) ((this).(@incoming)) = (@ofWishlist) }
lone sig ofEmails extends ActivityEdge
{}
{ ((this).(@source)) = (@aSelectProductInEmail) ((this).(@target)) = (@mnNonWithlist) }
one sig ofCatalogs extends ActivityEdge
{}
{ ((this).(@source)) = (@aSelectProductFromCatalog) ((this).(@target)) = (@mnNonWithlist) }
lone sig ofSearching extends ActivityEdge
{}
{ ((this).(@source)) = (@aSearchProduct) ((this).(@target)) = (@mnNonWithlist) }
lone sig ofWishLists extends ActivityEdge
{}
{ ((this).(@source)) = (@aSelectProductFromWishlist) ((this).(@target)) = (@mnFinalNode) }
one sig mnNonWithlist extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofNonWishLists) ((this).(@incoming)) = (((@ofEmails)+(@ofCatalogs))+(@ofSearching)) }
one sig ofNonWishLists extends ActivityEdge
{}
{ ((this).(@source)) = (@mnNonWithlist) ((this).(@target)) = (@dnStorefront) }
one sig dnStorefront extends ActivityNode
{}
{ ((this).(@outgoing)) = ((@ofGeneralProduct)+(@ofSkipProductVariants)) ((this).(@incoming)) = (@ofNonWishLists) }
lone sig ofSkipProductVariants extends ActivityEdge
{}
{ ((this).(@source)) = (@dnStorefront) ((this).(@target)) = (@pinProduct) }
lone sig ofGeneralProduct extends ActivityEdge
{}
{ ((this).(@source)) = (@dnStorefront) ((this).(@target)) = (@cbGeneralProduct) }
lone sig cbGeneralProduct extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofGeneralProducts) ((this).(@incoming)) = (@ofGeneralProduct) }
lone sig ofGeneralProducts extends ActivityEdge
{}
{ ((this).(@source)) = (@cbGeneralProduct) ((this).(@target)) = (@aProductConfiguration) }
lone sig aProductConfiguration extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofProductConfiguration) ((this).(@incoming)) = (@ofGeneralProducts) }
lone sig ofProductConfiguration extends ActivityEdge
{}
{ ((this).(@source)) = (@aProductConfiguration) ((this).(@target)) = (@mnFinalNode) }
one sig mnFinalNode extends ActivityNode
{}
{ ((this).(@outgoing)) = (@ofFinalNode) ((this).(@incoming)) = ((@ofProductConfiguration)+(@ofWishLists)) }
one sig ofFinalNode extends ActivityEdge
{}
{ ((this).(@source)) = (@mnFinalNode) ((this).(@target)) = (@pinProduct) }
one sig pinProduct extends ActivityNode
{}
{ no (this).(@outgoing) ((this).(@incoming)) = ((@ofFinalNode)+(@ofSkipProductVariants)) }
one sig eShop
{ storefront : one eShop_storefront
, businessmanagement : one eShop_businessmanagement }
{}
one sig eShop_storefront
{ parent : one eShop
, catalog : one eShop_storefront_catalog
, wishlist = eShop_storefront_wishlist }
{}
one sig eShop_storefront_catalog
{ parent : one eShop_storefront
, productinformation : one eShop_storefront_catalog_productinformation
, Searching = eShop_storefront_catalog_Searching }
{}
one sig eShop_storefront_catalog_productinformation
{ parent : one eShop_storefront_catalog
, productvariants = eShop_storefront_catalog_productinformation_productvariants }
{}
lone sig eShop_storefront_catalog_productinformation_productvariants
{ parent : one eShop_storefront_catalog_productinformation }
{}
lone sig eShop_storefront_catalog_Searching
{ parent : one eShop_storefront_catalog }
{}
lone sig eShop_storefront_wishlist
{ parent : one eShop_storefront }
{}
one sig eShop_businessmanagement
{ parent : one eShop
, Targeting = eShop_businessmanagement_Targeting }
{}
lone sig eShop_businessmanagement_Targeting
{ parent : one eShop_businessmanagement
, Displayandnotification : one eShop_businessmanagement_Targeting_Displayandnotification }
{}
one sig eShop_businessmanagement_Targeting_Displayandnotification
{ parent : one eShop_businessmanagement_Targeting
, Assignmenttopagetypesfordisplay = eShop_businessmanagement_Targeting_Displayandnotification_Assignmenttopagetypesfordisplay
, Productflagging = eShop_businessmanagement_Targeting_Displayandnotification_Productflagging
, Emails = eShop_businessmanagement_Targeting_Displayandnotification_Emails }
{  some (eShop_businessmanagement_Targeting_Displayandnotification_Assignmenttopagetypesfordisplay + eShop_businessmanagement_Targeting_Displayandnotification_Productflagging + eShop_businessmanagement_Targeting_Displayandnotification_Emails) }
lone sig eShop_businessmanagement_Targeting_Displayandnotification_Assignmenttopagetypesfordisplay
{ parent : one eShop_businessmanagement_Targeting_Displayandnotification }
{}
lone sig eShop_businessmanagement_Targeting_Displayandnotification_Productflagging
{ parent : one eShop_businessmanagement_Targeting_Displayandnotification }
{}
lone sig eShop_businessmanagement_Targeting_Displayandnotification_Emails
{ parent : one eShop_businessmanagement_Targeting_Displayandnotification }
{}
fact { (some ((((@eShop).(@businessmanagement)).(@Targeting)).(@Displayandnotification)).(@Emails)) <=> (some @ofEmail) (some ((((@eShop).(@businessmanagement)).(@Targeting)).(@Displayandnotification)).(@Emails)) <=> (some @aSelectProductInEmail) (some ((((@eShop).(@businessmanagement)).(@Targeting)).(@Displayandnotification)).(@Emails)) <=> (some @ofEmails) (some (((@eShop).(@storefront)).(@catalog)).(@Searching)) <=> (some @ofSearch) (some (((@eShop).(@storefront)).(@catalog)).(@Searching)) <=> (some @aSearchProduct) (some (((@eShop).(@storefront)).(@catalog)).(@Searching)) <=> (some @ofSearching) (some ((@eShop).(@storefront)).(@wishlist)) <=> (some @ofWishlist) (some ((@eShop).(@storefront)).(@wishlist)) <=> (some @aSelectProductFromWishlist) (some ((@eShop).(@storefront)).(@wishlist)) <=> (some @ofWishLists) (some ((((@eShop).(@storefront)).(@catalog)).(@productinformation)).(@productvariants)) <=> (some @cbGeneralProduct) (some ((((@eShop).(@storefront)).(@catalog)).(@productinformation)).(@productvariants)) <=> (some @ofGeneralProduct) (some ((((@eShop).(@storefront)).(@catalog)).(@productinformation)).(@productvariants)) <=> (some @ofGeneralProducts) (some ((((@eShop).(@storefront)).(@catalog)).(@productinformation)).(@productvariants)) <=> (some @aProductConfiguration) (some ((((@eShop).(@storefront)).(@catalog)).(@productinformation)).(@productvariants)) <=> (some @ofProductConfiguration) not ((some @ofSkipProductVariants) <=> (some @ofGeneralProduct)) }
fact { (((not (some ((((@eShop).(@businessmanagement)).(@Targeting)).(@Displayandnotification)).(@Emails))) && (not (some ((@eShop).(@storefront)).(@wishlist)))) && (not (some (((@eShop).(@storefront)).(@catalog)).(@Searching)))) && (not (some ((((@eShop).(@storefront)).(@catalog)).(@productinformation)).(@productvariants))) }
